/*
Copyright (c) 2009, Jon Langseth, LiNC
All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
  * Redistributions in binary form must reproduce the above copyright 
    notice, this list of conditions and the following disclaimer in the 
    documentation and/or other materials provided with the distribution.
  * Neither the name of the LiNC nor the names of its contributors
    may be used to endorse or promote products derived from this software 
    without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include "barcodefile.h"

int barcodefile(char *bcstring, char *filename) {
	struct Barcode_Item * bc;
	FILE *ofile;
	char *ofilen, *tmp;
	int flags;
	MagickWand *magick_wand;

	flags = BARCODE_39 | BARCODE_NO_CHECKSUM | BARCODE_OUT_EPS;

	tmp = tmpnam( NULL );

	ofilen = malloc( (strlen(tmp) + 4) * sizeof(char) );
	sprintf(ofilen, "%s.eps", tmp);

	ofile = fopen(ofilen, "w");
	if ( !ofile ) 
	{
		return 1;
	}
	if (Barcode_Encode_and_Print(bcstring, ofile, 300, 100, 0, 0, flags) < 0) 
		return 2;
	fclose(ofile);

	magick_wand = NewMagickWand();

	if (! MagickReadImage( magick_wand, ofilen) )
	{
		remove(ofilen);
		DestroyMagickWand(magick_wand);
		return 3;
	}
	if (! MagickWriteImage( magick_wand, filename ) )
	{
		return 4;
	}
	DestroyMagickWand(magick_wand);
	remove(ofilen);

	return 0;
}

